
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>一个利用memory block分配机制的高性能的内存管理器类 / 憋错料</title>

    <meta name="description" content="一个利用memory block分配机制的高性能的内存管理器类 问题描述: 1.众所周知,内存管理机制几乎存在于一切优秀的系统中.这样做原因不外乎以下几点:1.改善性能:2.减少碎片的产生:3.侦测系统的内存使用情况,便于调错,便于了解系统的内存使用,以对系统的架构从内存使用层面上进行设计考量: 2.我前面有文已经说明,内存管理的机制一般分为:1.预先分配大量等尺寸的块,自己维护,逐次满足对单个内存单元的请求:2.释放的内存也自己维护,以便重复使用:3.使用定长和变长机制进行内存管理. 3.本文试着以较大尺寸(4096)的内存块为分配单元,然后在一个块中利用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">一个利用memory block分配机制的高性能的内存管理器类</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2><strong>问题描述：</strong></h2>
<p>1.众所周知，内存管理机制几乎存在于一切优秀的系统中。这样做原因不外乎以下几点：1.改善性能；2.减少碎片的产生；3.侦测系统的内存使用情况，便于调错，便于了解系统的内存使用，以对系统的架构从内存使用层面上进行设计考量；</p>
<p>2.我前面有文已经说明，内存管理的机制一般分为：1.预先分配大量等尺寸的块，自己维护，逐次满足对单个内存单元的请求；2.释放的内存也自己维护，以便重复使用；3.使用定长和变长机制进行内存管理。</p>
<p>3.本文试着以较大尺寸（4096）的内存块为分配单元，然后在一个块中利用指针偏移来满足小对象的内存申请，当当前块内存耗尽时，又分配同样尺寸的内存块，重复以前工作。块与块之间靠指针维护（next)。</p>
<p>4.程序交还的内存，以内存尺寸为键，存入STL map；</p>
<p>5.当STL map中有内存时，优先从此中寻找满足的给定尺寸的内存需求；</p>
<p>6.和直接系统申请内存对比测试，发现，执行相同的操作，本内存管理器所消耗时间仅为系统内存申请耗时的<strong>十分之一</strong>；</p>
<h2><strong>程序代码：</strong></h2>
<p><strong></strong></p>
<pre>#ifndef _MEMORY_BLOCK_POOL_H_
#define _MEMORY_BLOCK_POOL_H_

#include &lt;stdlib.h&gt;
#include &lt;vector&gt;

#include &quot;windows.h&quot;

#define ALIGN( size, bits )  ( ( ( ( size - 1 ) &gt;&gt; bits ) + 1 ) &lt;&lt; bits )

/*
* memory pool fixed length block
*
*
*/
class MemoryBlockPool
{
public:
	static const int MAXBLOCK = 256;
	static const int MALLOCKSIZE = 4096;
	static const int DEFAULTBASELEN = 4;

	typedef struct tagMemStatInfo
	{
		char*   allocMem;
		size_t  allocSize;

		tagMemStatInfo():allocMem(0),allocSize(0)
		{

		}

		tagMemStatInfo( char* mem, size_t size ):allocMem(mem),
			           allocSize(size)
		{

		}

	}MemStatInfo, *pMemStatInfo;

	typedef struct tagMemoryBlock
	{
		std::vector&lt;char*&gt;      Block;
		size_t                  validIdx;

		tagMemoryBlock():Block(), validIdx(0)
		{

		}
	}MemoryBlock, *pMemoryBlock;

	typedef std::vector&lt;char*&gt; BlockContainer;

	/*
	*
	*
	*/
	MemoryBlockPool( size_t baseLen =  DEFAULTBASELEN ):m_pool(0),
		             m_poolSize(0), m_baseLen(baseLen),
					 m_memStat()
	{
		Init( m_baseLen );
	}

	/*
	*
	*
	*/
	~MemoryBlockPool()
	{
		Release();
	}

	/*
	* Release all memory allocated
	*
	*/
	void Release()
	{
		std::vector&lt;MemStatInfo&gt;::iterator iter = m_memStat.begin();
		while( iter != m_memStat.end() )
		{
			free( iter-&gt;allocMem );
			++iter;
		}

		for( size_t i = 0; i &lt; m_poolSize; i++ )
		{
			m_pool[i].Block.clear();
		}
	}

	/*
	* get memory for given length from cahce array or os
	*
	*/
	void* Malloc( size_t len )
	{
		assert( len &gt; 0 );
		size_t size = ALIGN( len, 2 );
		if( size &gt; MAXBLOCK )
		{
			return malloc(size);
		}

		if( !m_pool[size].Block.size() )
		{
			size_t memLen = size + 4;
			char* buf = (char*)malloc( MALLOCKSIZE );
			size_t blockNums = MALLOCKSIZE / memLen;

			BlockContainer&amp; container = m_pool[size].Block;
			container.reserve( blockNums );
			for( size_t i = 0; i &lt; blockNums; i++ )
			{
				*(buf + i * size) = i;
				container.push_back( buf + i * size );
			}

			m_memStat.push_back( MemStatInfo( buf, MALLOCKSIZE ) );

		}
		else if( m_pool[size].validIdx == m_pool[size].Block.size() )
		{
			size_t memLen = size + 4;
			char* buf = (char*)malloc( MALLOCKSIZE );
			size_t blockNums = MALLOCKSIZE / memLen;

			BlockContainer&amp; container = m_pool[size].Block;
			for( size_t i = 0; i &lt; blockNums; i++ )
			{
				*(int*)(buf + i * size) = i + container.size();
				container.push_back( buf + i * size );
			}
		}

		char* buf = m_pool[size].Block.at( m_pool[size].validIdx );
		m_pool[size].validIdx++;

		return buf + 4;

	}

	/*
	* give back memory to cache or os
	*
	*/
	void Free( void* mem, size_t len )
	{
		assert( len &gt; 0 );
		size_t size = ALIGN( len, 2 );
		if( size &gt; MAXBLOCK )
		{
			return free( mem );
		}

		char* buf = (char*)mem;
		buf -= 4;

		if( m_pool[size].validIdx )
		{
			Swap( m_pool[size].Block.at( m_pool[size].validIdx - 1), buf );
			m_pool[size].validIdx--;
		}

	}

private:

	void Swap( char*&amp; bufFirst, char*&amp; bufSecond )
	{
		char* temp = bufFirst;
		bufFirst = bufSecond;
		bufSecond = temp;
	}

	/*
	*
	*
	*/
	void Init( size_t baseLen )
	{
		m_poolSize = MAXBLOCK / baseLen;
		m_pool = new MemoryBlock[m_poolSize];
	}

private:
	MemoryBlock         *m_pool;      // memory block array
	size_t               m_poolSize;  // the size of memory block array
	size_t               m_baseLen;   //
	std::vector&lt;MemStatInfo&gt; m_memStat;

};

//test object one
typedef struct tagTestObjFirst
{
	int first;
	int second;

	tagTestObjFirst():first(0), second(0)
	{

	}

	tagTestObjFirst( int i, int j ):first(i), second(j)
	{

	}
}TestObjFirst, *pTestObjFrist;

// test object two
typedef struct tagTestObjSecond
{
	int first;
	int second;
	std::string  name;

	tagTestObjSecond():first(0), second(0)
	{

	}

	tagTestObjSecond( int i, int j, const char* str ):first(i), second(j), name( str )
	{

	}

}TestObjSecond, *pTestObjSecond;

/*
* Test os memory operation
*
*/
void BlockTestOSMemory()
{
	unsigned long start = GetTickCount();

	const int len = 2000000;
	int halfLen = len / 2;

	pTestObjFrist* objs = new pTestObjFrist[len];
	pTestObjSecond* objExts = new pTestObjSecond[len];
	for( int i = 0; i &lt; len; i++ )
	{
		objs[i] = new TestObjFirst( i, i );
		objExts[i] = new TestObjSecond( i, i, &quot;test&quot; );
		delete objs[i];
		delete objExts[i];

	}

	unsigned long interval = GetTickCount() - start;
	printf(&quot; system call consume time  %d for memory operation \n&quot;, interval );

	delete [] objs;
	delete [] objExts;
}

/*
*Test memory pool
*
*
*/
void BlockTestMemoryBlock()
{
	unsigned long start = GetTickCount();

	const int len = 2000000;
	int halfLen = len / 2;

	MemoryBlockPool memPool;
	pTestObjFrist* objs = new pTestObjFrist[len];
	pTestObjSecond* objExts = new pTestObjSecond[len];
	for( int i = 0; i &lt; len; i++ )
	{
		void* buf = memPool.Malloc( sizeof(TestObjFirst) );
		objs[i] = new (buf) TestObjFirst( i, i );

		buf = memPool.Malloc( sizeof(TestObjSecond) );
		objExts[i] = new (buf) TestObjSecond( i, i, &quot;test&quot; );

		memPool.Free( buf, sizeof(TestObjFirst) );

		memPool.Free( buf, sizeof(TestObjSecond) );

	}

	unsigned long interval = GetTickCount() - start;
	printf(&quot; memory pool call consume time  %d for memory operation \n&quot;, interval );

	delete [] objs;
	delete [] objExts;
}

/*
*Test interface for memory operation
*
*
*/
void TestSuiteCacheBlock()
{

	BlockTestMemoryBlock();
	BlockTestOSMemory();
}

#endif
</pre>
<p>compile and run in visual studio 2005</p>
<p><P>一个利用memory block分配机制的高性能的内存管理器类</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 06:26:09 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/algorithm/" title="algorithm">algorithm</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e7%bb%93%e6%9e%84/" title="数据结构">数据结构</a>, <a href="https://www.biecuoliao.com/tag/%e5%86%85%e5%ad%98%e7%ae%a1%e7%90%86/" title="内存管理">内存管理</a>, <a href="https://www.biecuoliao.com/tag/performance/" title="performance">performance</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>一个利用memory block分配机制的高性能的内存管理器类的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLLXQAM.html" rel="bookmark">&lbrack;C&plus;&plus;&rsqb;内存管理器--谈论如何自定义内存分配机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内存管理器–谈论如何自定义内存分配机制 Memory pools, also called fixed-size blocks allocation, is the use of pools for memory management that allows dynamic memory allocation comparable to malloc or C++'s operator new. As those implementations suffer from fragmentation			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pPjgx4.html" rel="bookmark">STL内存管理器的分配策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				STL提供了很多泛型容器,如vector,list和map.程序员在使用这些容器时只需关心何时往容器内塞对象,而不用关心如何管理内存,需要用多少内存,这些STL容器极大地方便了C++程序的编写.例如可以通过以下语句创建一个vector,它实际上是一个按需增长的动态数组,其每个元素的类型为int整型: stl::vector&lt;int&gt; array; 拥有这样一个动态数组后,用户只需要调用push_back方法往里面添加对象,而不需要考虑需要多少内存: array.push_back(10); a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35m9NR3.html" rel="bookmark">&lbrack;转帖&rsqb;Linux分页机制之分页机制的演变--Linux内存管理&lpar;七&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux分页机制之分页机制的演变--Linux内存管理(七) 2016年09月01日 20:01:31 JeanCheng 阅读数:4543 https://blog.csdn.net/gatieme/article/details/52402967 ~ 版权声明:本文为博主原创文章 &amp;&amp; 转载请著名出处 @ http://blog.csdn.net/gatieme https://blog.csdn.net/gatieme/article/details/52402967 日期 内核版			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVz9kdM.html" rel="bookmark">一个简单而强大的单片机内存管理器-不带内存碎片整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				单片机简单内存管理器 本代码基于无操作系统的STM32单片机开发,功能强大,可申请到地址空间连续的不同大小的内存空间,且用户接口简单,使用方便 转载请注明出处:http://blog.csdn.net/u011833609/article/details/46834203 memory.h #ifndef __MEMORY_H__ #define __MEMORY_H__ #include &quot;stdio.h&quot; #include &quot;string.h&quot; #include			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47EpQ10.html" rel="bookmark">Process memory buffer分配机制&mdash;&mdash;show buffers相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				思科设备巡检过程中,往往要求工程师注意show buffers输出的failures及misses,出于对buffer以及其中各项参数的意义的好奇,特进行了探究,遂编写此文档. 1.路由器数据转发机制 1.1 转发机制概述 (1)Process Switching 基于进程的转发,数据流量的处理需要依赖RP(Routing Processor). (2)Fast Switching 类似于MLS技术,数据流量在第一次被转发时,是基于进程的转发方式,需要依赖RP. 在第一次转发时,建立起转发缓存,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bYvVYM.html" rel="bookmark">memcached学习&mdash;&mdash;memcached的内存分配机制Slab Allocation、内存使用机制LRU、常用监控记录（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内存分配机制Slab Allocation 本文参考博客:https://my.oschina.net/bieber/blog/505458 Memcached的内存分配是以slabs为单位的,会根据初始chunk大小.增长因子.存储数据的大小实际划分出多个不同的slabs class,slab class中包含若干个等大小的trunk和一个固定48byte的item信息.trunk是按页存储的,每一页成为一个page(默认1M). 1.slabs.slab class.page三者关系: sl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aoWbk4.html" rel="bookmark">windows内存详解（一） 全面介绍Windows内存管理机制及C&plus;&plus;内存分配实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				十分感谢MS社区的帖子,讲得很好~ http://social.technet.microsoft.com/Forums/zh-CN/2219/thread/afc1269f-fe08-4dc7-bb94-c395d607e536 (一):进程空间 在编程中,很多Windows或C++的内存函数不知道有什么区别,更别谈有效使用:根本的原因是,没有清楚的理解操作系统的内存管理机制,本文企图通过简单的总结描述,结合实例来阐明这个机制. 本文目的: 对Windows内存管理机制了解清楚,有效的利用C+			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vWnWR4.html" rel="bookmark">全面介绍内存管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				全面介绍Windows内存管理机制及C++内存分配实例 十分感谢MS社区的帖子,讲得很好~ http://social.technet.microsoft.com/Forums/zh-CN/2219/thread/afc1269f-fe08-4dc7-bb94-c395d607e536 (一):进程空间 在编程中,很多Windows或C++的内存函数不知道有什么区别,更别谈有效使用:根本的原因是,没有清楚的理解操作系统的内存管理机制,本文企图通过简单的总结描述,结合实例来阐明这个机制. 本文目的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmKNrP3.html" rel="bookmark">Spark内存管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark内存管理机制 Spark 作为一个基于内存的分布式计算引擎,其内存管理模块在整个系统中扮演着非常重要的角色.理解 Spark 内存管理的基本原理,有助于更好地开发 Spark 应用程序和进行性能调优. 在执行 Spark 的应用程序时,Spark 集群会启动 Driver 和 Executor 两种 JVM 进程,前者为主控进程,负责创建 Spark 上下文,提交 Spark 作业(Job),并将作业转化为计算任务(Task),在各个 Executor 进程间协调任务的调度,后者负责在			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OzjG0.html" rel="bookmark" class="title">查询作业</a>
					<div>
						开源指开源你对源码进行二次开发进行修改bug修复等版权可以标为自己开发.不开源则和开源相反你不知道源码内容无法对源码进行修改等版权也是开发人所有.开源(Open Source,开放源码)被非盈利软件组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDZddM.html" rel="bookmark" class="title">FATE</a>
					<div>
						FATE Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submissi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49b6bgM.html" rel="bookmark" class="title">jboss之mod&lowbar;cluster集群</a>
					<div>
						1.通过对jboss集群部署,我们看到几乎没怎么配置就能运行了,很神奇,那么mod_cluster是怎么发现jboss server的呢? 主要是&lt;IfModule manager_module ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JzN5b4.html" rel="bookmark" class="title">OSI七层模型具体解释</a>
					<div>
						OSI 七层模型通过七个层次化的结构模型使不同的系统不同的网络之间实现可靠的通讯.因此其最基本的功能就是帮助不同类型的主机实现传输数据 . 完毕中继功能的节点通常称为中继系统.在OSI七层模型中,处于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBR7LqM.html" rel="bookmark" class="title">OC iOS开发 代码布局</a>
					<div>
						代码布局抛弃storyboard,用代码生成界面,它的优劣不谈 首先在项目设置中,更改应用的“入口” 不选main,清空它 然后在AppDelegate.m中,更改(添加内容),别忘了import 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQy7a0.html" rel="bookmark" class="title">使用leangoo实现多泳道任务看板</a>
					<div>
						在敏捷开发的实践当中,通过可视化的任务看板来实现团队协同和透明化管理是必不可少的一个实践.通过可视化的任务看板我们可以达到如下几个目的: 1. 可视化管理团队的目标;2. 明确目标的优先级;3. 明确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/478pEkM.html" rel="bookmark" class="title">简单规律---BD String</a>
					<div>
						HDU   5694 Problem Description 众所周知,度度熊喜欢的字符只有两个:B和D.今天,它发明了一种用B和D组成字符串的规则:S(1)=BS(2)=BBDS(3)=BBDBBD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPlwdM.html" rel="bookmark" class="title">NFS服务的配置过程。</a>
					<div>
						NFS(Network File System)即网络文件系统,是由Sun公司开发的一种通过网络方式共享系统的通用共享解决方案.目前NFS有3个版本,分别为NFSv2.NFSv3.NFSv4.NFSv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGp2eo0.html" rel="bookmark" class="title">代码案例&lpar;结构体&comma;函数指针&comma;指针函数&comma;冒泡排序&rpar; 修改</a>
					<div>
						#import &lt;Foundation/Foundation.h&gt; typedef struct {     char name[20];     int age;     float s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLxo83.html" rel="bookmark" class="title">code complete part1</a>
					<div>
						最近在看code complete,学习了一些东西,作为点滴,记录下来. 关于类: 类的接口抽象应该一致 类的接口要可编程,不要对类的使用者做过多的假设.不要出现类似于:A的输入量一定要大于多少小于多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koRap0.html" rel="bookmark" class="title">phpcms v9取消验证码</a>
					<div>
						phpcms/modules/admin/index.php// $code = isset($_POST['code']) &amp;&amp; trim($_POST['code']) ? tri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEN7k4.html" rel="bookmark" class="title">Centos6&period;5 安装rabbitmq</a>
					<div>
						安装分两步 1.      从EPEL仓库安装Erlang 1)      使服务器能够使用EPEL,执行如下命令即可 su -c 'rpm -Uvhhttp://download.fedorapro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEpWv0.html" rel="bookmark" class="title">POSIX 线程编程（一）简介</a>
					<div>
						简介 在共享内存的多处理器结构中,可以用线程来实现并行.对于UNIX系统, IEEE POSIX 1003.1c标准规定了C语言线程编程接口的标准.这份标准的实现就是POSIX threads, 或者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXlwXbM.html" rel="bookmark" class="title">java线程池框架源代码分析</a>
					<div>
						相关类Executor,Executors.AbstractExecutorService.ExecutorService Executor:整个线程池运行者框架的顶层接口. 定义了一个execute ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9AkE0.html" rel="bookmark" class="title">软交所--项目管理需求分析需考虑的几个因素</a>
					<div>
						作为软件开发公司要做好正版软件开发,就要做好软件定制.做好项目管理,浅析项目管理需求分析工作机制需考虑的几个因素: (1)抓住决策者最迫切关心的问题,引起重视.用户方决策者对项目的关心重视程度是项目能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zarym0.html" rel="bookmark" class="title">也谈在 &period;NET 平台上使用 Scala 语言&lpar;中&rpar;</a>
					<div>
						说我在单位的安装 Ubuntu 9.10 操作系统 Lenovo ThinkCentre M4000t 台式机上写完&quot;也谈在 .NET 平台上使用 Scala 语言(上)&quot;之后不久 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRZL2M.html" rel="bookmark" class="title">中颖SH79F1616 PWM初始化程序</a>
					<div>
						//========pwm.h============================================= #ifndef _PWM_H_ #define _PWM_H_ #define ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAqbk3.html" rel="bookmark" class="title">WdatePicker显示乱码</a>
					<div>
						1.修改zh-cn.js内容: var $lang={ errAlertMsg: &quot;不合法的日期格式或者日期超出限定范围,需要撤销吗?&quot;, aWeekStr: [&quot;周&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ja5D7M.html" rel="bookmark" class="title">倒计时（距离活动结束还有X天X小时X分X秒）</a>
					<div>
						一个简单的倒计时,可以设定结束时间,然后自动计算出距离活动结束还有X天X小时X分X秒. 废话不多说,上代码,挺简单的,代码里有注释: // 活动倒计时 var time_end = new Date( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bZRxV0.html" rel="bookmark" class="title">Pycharm创建的virtualenv环境缺失pip&period;exe的问题（Windows系统）</a>
					<div>
						Windows环境: 1. Python安装在d:\Python\Python35下, Python新版本安装时默认会勾选pip功能 2. PyCharm的Settings中Create Virtua ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
